Index: uspace/lib/ui/include/ui/resource.h
===================================================================
--- uspace/lib/ui/include/ui/resource.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/include/ui/resource.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -38,4 +38,5 @@
 
 #include <errno.h>
+#include <gfx/color.h>
 #include <gfx/context.h>
 #include <gfx/font.h>
@@ -49,4 +50,7 @@
 extern void ui_resource_expose(ui_resource_t *);
 extern gfx_font_t *ui_resource_get_font(ui_resource_t *);
+extern bool ui_resource_is_textmode(ui_resource_t *);
+extern gfx_color_t *ui_resource_get_wnd_face_color(ui_resource_t *);
+extern gfx_color_t *ui_resource_get_wnd_text_color(ui_resource_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/ui.h
===================================================================
--- uspace/lib/ui/include/ui/ui.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/include/ui/ui.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -39,4 +39,5 @@
 #include <display.h>
 #include <errno.h>
+#include <gfx/coord.h>
 #include <io/console.h>
 #include <stdbool.h>
@@ -53,4 +54,5 @@
 extern bool ui_is_textmode(ui_t *);
 extern bool ui_is_fullscreen(ui_t *);
+extern errno_t ui_get_rect(ui_t *, gfx_rect_t *);
 extern errno_t ui_suspend(ui_t *);
 extern errno_t ui_resume(ui_t *);
Index: uspace/lib/ui/include/ui/window.h
===================================================================
--- uspace/lib/ui/include/ui/window.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/include/ui/window.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -65,4 +65,5 @@
 extern void ui_window_set_ctl_cursor(ui_window_t *, ui_stock_cursor_t);
 extern errno_t ui_window_paint(ui_window_t *);
+extern errno_t ui_window_def_minimize(ui_window_t *);
 extern errno_t ui_window_def_maximize(ui_window_t *);
 extern errno_t ui_window_def_unmaximize(ui_window_t *);
Index: uspace/lib/ui/private/pbutton.h
===================================================================
--- uspace/lib/ui/private/pbutton.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/private/pbutton.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -62,7 +62,9 @@
 	gfx_rect_t rect;
 	/** Caption */
-	const char *caption;
+	char *caption;
 	/** Button is selected as default */
 	bool isdefault;
+	/** Button light is on */
+	bool light;
 	/** Button is currently held down */
 	bool held;
Index: uspace/lib/ui/private/resource.h
===================================================================
--- uspace/lib/ui/private/resource.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/private/resource.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -66,4 +66,6 @@
 	/** Button face color */
 	gfx_color_t *btn_face_color;
+	/** Lit button face color */
+	gfx_color_t *btn_face_lit_color;
 	/** Button text color */
 	gfx_color_t *btn_text_color;
Index: uspace/lib/ui/private/wdecor.h
===================================================================
--- uspace/lib/ui/private/wdecor.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/private/wdecor.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -65,4 +65,6 @@
 	/** Window is maximized */
 	bool maximized;
+	/** Minimize button */
+	struct ui_pbutton *btn_min;
 	/** Maximize button */
 	struct ui_pbutton *btn_max;
@@ -80,4 +82,8 @@
 	/** Title bar rectangle */
 	gfx_rect_t title_bar_rect;
+	/** Window caption rectangle */
+	gfx_rect_t caption_rect;
+	/** Minimize button rectangle */
+	gfx_rect_t btn_min_rect;
 	/** Maximize button rectangle */
 	gfx_rect_t btn_max_rect;
@@ -88,4 +94,5 @@
 } ui_wdecor_geom_t;
 
+extern void ui_wdecor_minimize(ui_wdecor_t *);
 extern void ui_wdecor_maximize(ui_wdecor_t *);
 extern void ui_wdecor_unmaximize(ui_wdecor_t *);
Index: uspace/lib/ui/private/window.h
===================================================================
--- uspace/lib/ui/private/window.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/private/window.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -112,4 +112,5 @@
 
 extern display_stock_cursor_t wnd_dcursor_from_cursor(ui_stock_cursor_t);
+extern void ui_window_send_minimize(ui_window_t *);
 extern void ui_window_send_maximize(ui_window_t *);
 extern void ui_window_send_unmaximize(ui_window_t *);
Index: uspace/lib/ui/src/paint.c
===================================================================
--- uspace/lib/ui/src/paint.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/src/paint.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -529,4 +529,33 @@
 }
 
+/** Paint minimize icon.
+ *
+ * @param resource UI resource
+ * @param pos Center position
+ * @param w Icon width
+ * @param h Icon height
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_minicon(ui_resource_t *resource, gfx_coord2_t *pos,
+    gfx_coord_t w, gfx_coord_t h)
+{
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rc = gfx_set_color(resource->gc, resource->btn_text_color);
+	if (rc != EOK)
+		return rc;
+
+	rect.p0.x = pos->x - w / 2;
+	rect.p0.y = pos->y + h / 2 - 2;
+	rect.p1.x = rect.p0.x + w;
+	rect.p1.y = rect.p0.y + 2;
+	rc = gfx_fill_rect(resource->gc, &rect);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
 /** Paint maximize icon.
  *
@@ -922,5 +951,5 @@
 	tfmt.color = fmt->color;
 	tfmt.halign = fmt->halign;
-	tfmt.justify_width = fmt->justify_width;
+	tfmt.width = fmt->width;
 	tfmt.valign = fmt->valign;
 	tfmt.underline = false;
Index: uspace/lib/ui/src/pbutton.c
===================================================================
--- uspace/lib/ui/src/pbutton.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/src/pbutton.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -54,5 +54,7 @@
 enum {
 	ui_pb_press_dx = 1,
-	ui_pb_press_dy = 1
+	ui_pb_press_dy = 1,
+	ui_pb_pad_x = 2,
+	ui_pb_pad_x_text = 1
 };
 
@@ -114,4 +116,5 @@
 
 	ui_control_delete(pbutton->control);
+	free(pbutton->caption);
 	free(pbutton);
 }
@@ -183,4 +186,43 @@
 {
 	pbutton->isdefault = isdefault;
+}
+
+/** Get button light status.
+ *
+ * @param pbutton Button
+ * @return @c true iff light is on
+ */
+bool ui_pbutton_get_light(ui_pbutton_t *pbutton)
+{
+	return pbutton->light;
+}
+
+/** Turn button light on or off.
+ *
+ * @param pbutton Button
+ * @param light @c true iff button should be lit
+ */
+void ui_pbutton_set_light(ui_pbutton_t *pbutton, bool light)
+{
+	pbutton->light = light;
+}
+
+/** Set push button caption.
+ *
+ * @param pbutton Button
+ * @param caption New caption
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_pbutton_set_caption(ui_pbutton_t *pbutton, const char *caption)
+{
+	char *dcaption;
+
+	dcaption = str_dup(caption);
+	if (dcaption == NULL)
+		return ENOMEM;
+
+	free(pbutton->caption);
+	pbutton->caption = dcaption;
+	return EOK;
 }
 
@@ -303,5 +345,7 @@
 	gfx_text_fmt_t fmt;
 	gfx_rect_t rect;
+	gfx_rect_t irect;
 	gfx_coord_t thickness;
+	gfx_color_t *color;
 	bool depressed;
 	errno_t rc;
@@ -315,5 +359,8 @@
 	rect.p1.y = pbutton->rect.p1.y - thickness;
 
-	rc = gfx_set_color(pbutton->res->gc, pbutton->res->btn_face_color);
+	color = pbutton->light ? pbutton->res->btn_face_lit_color :
+	    pbutton->res->btn_face_color;
+
+	rc = gfx_set_color(pbutton->res->gc, color);
 	if (rc != EOK)
 		goto error;
@@ -340,4 +387,5 @@
 	} else {
 		/* Text decoration */
+		ui_paint_get_inset_frame_inside(pbutton->res, &rect, &irect);
 		gfx_text_fmt_init(&fmt);
 		fmt.font = pbutton->res->font;
@@ -345,4 +393,6 @@
 		fmt.halign = gfx_halign_center;
 		fmt.valign = gfx_valign_center;
+		fmt.abbreviate = true;
+		fmt.width = irect.p1.x - irect.p0.x - 2 * ui_pb_pad_x;
 
 		rc = gfx_puttext(&pos, &fmt, pbutton->caption);
@@ -422,4 +472,8 @@
 	fmt.halign = gfx_halign_center;
 	fmt.valign = gfx_valign_center;
+	fmt.abbreviate = true;
+	fmt.width = rect.p1.x - rect.p0.x - 2 * ui_pb_pad_x_text;
+	if (fmt.width < 1)
+		fmt.width = 1;
 
 	rc = gfx_puttext(&pos, &fmt, pbutton->caption);
Index: uspace/lib/ui/src/resource.c
===================================================================
--- uspace/lib/ui/src/resource.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/src/resource.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -62,4 +62,5 @@
 	gfx_color_t *btn_frame_color = NULL;
 	gfx_color_t *btn_face_color = NULL;
+	gfx_color_t *btn_face_lit_color = NULL;
 	gfx_color_t *btn_text_color = NULL;
 	gfx_color_t *btn_highlight_color = NULL;
@@ -114,4 +115,8 @@
 		goto error;
 
+	rc = gfx_color_new_rgb_i16(0xe8e8, 0xe8e8, 0xe8e8, &btn_face_lit_color);
+	if (rc != EOK)
+		goto error;
+
 	rc = gfx_color_new_rgb_i16(0, 0, 0, &btn_text_color);
 	if (rc != EOK)
@@ -227,4 +232,5 @@
 	resource->btn_frame_color = btn_frame_color;
 	resource->btn_face_color = btn_face_color;
+	resource->btn_face_lit_color = btn_face_lit_color;
 	resource->btn_text_color = btn_text_color;
 	resource->btn_highlight_color = btn_highlight_color;
@@ -263,4 +269,6 @@
 	if (btn_face_color != NULL)
 		gfx_color_delete(btn_face_color);
+	if (btn_face_lit_color != NULL)
+		gfx_color_delete(btn_face_lit_color);
 	if (btn_text_color != NULL)
 		gfx_color_delete(btn_text_color);
@@ -336,4 +344,5 @@
 	gfx_color_t *btn_frame_color = NULL;
 	gfx_color_t *btn_face_color = NULL;
+	gfx_color_t *btn_face_lit_color = NULL;
 	gfx_color_t *btn_text_color = NULL;
 	gfx_color_t *btn_highlight_color = NULL;
@@ -383,4 +392,8 @@
 		goto error;
 
+	rc = gfx_color_new_ega(0x30, &btn_face_lit_color);
+	if (rc != EOK)
+		goto error;
+
 	rc = gfx_color_new_ega(0x20, &btn_text_color);
 	if (rc != EOK)
@@ -486,4 +499,5 @@
 	resource->btn_frame_color = btn_frame_color;
 	resource->btn_face_color = btn_face_color;
+	resource->btn_face_lit_color = btn_face_lit_color;
 	resource->btn_text_color = btn_text_color;
 	resource->btn_highlight_color = btn_highlight_color;
@@ -522,4 +536,6 @@
 	if (btn_face_color != NULL)
 		gfx_color_delete(btn_face_color);
+	if (btn_face_lit_color != NULL)
+		gfx_color_delete(btn_face_lit_color);
 	if (btn_text_color != NULL)
 		gfx_color_delete(btn_text_color);
@@ -607,4 +623,5 @@
 	gfx_color_delete(resource->btn_frame_color);
 	gfx_color_delete(resource->btn_face_color);
+	gfx_color_delete(resource->btn_face_lit_color);
 	gfx_color_delete(resource->btn_text_color);
 	gfx_color_delete(resource->btn_highlight_color);
@@ -677,4 +694,34 @@
 }
 
+/** Determine if resource is textmode.
+ *
+ * @param resource UI resource
+ * @return @c true iff resource is textmode
+ */
+bool ui_resource_is_textmode(ui_resource_t *resource)
+{
+	return resource->textmode;
+}
+
+/** Get the UI window face color.
+ *
+ * @param resource UI resource
+ * @return UI window face color
+ */
+gfx_color_t *ui_resource_get_wnd_face_color(ui_resource_t *resource)
+{
+	return resource->wnd_face_color;
+}
+
+/** Get the UI window text color.
+ *
+ * @param resource UI resource
+ * @return UI window text color
+ */
+gfx_color_t *ui_resource_get_wnd_text_color(ui_resource_t *resource)
+{
+	return resource->wnd_text_color;
+}
+
 /** @}
  */
Index: uspace/lib/ui/src/scrollbar.c
===================================================================
--- uspace/lib/ui/src/scrollbar.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/src/scrollbar.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -840,5 +840,5 @@
 
 		ui_scrollbar_set_pos(scrollbar, spos);
-		ui_scrollbar_moved(scrollbar, spos);
+		ui_scrollbar_moved(scrollbar, scrollbar->pos);
 	}
 
Index: uspace/lib/ui/src/ui.c
===================================================================
--- uspace/lib/ui/src/ui.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/src/ui.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -524,4 +524,37 @@
 }
 
+/** Get UI screen rectangle.
+ *
+ * @param ui User interface
+ * @param rect Place to store bounding rectangle
+ */
+errno_t ui_get_rect(ui_t *ui, gfx_rect_t *rect)
+{
+	display_info_t info;
+	sysarg_t cols, rows;
+	errno_t rc;
+
+	if (ui->display != NULL) {
+		rc = display_get_info(ui->display, &info);
+		if (rc != EOK)
+			return rc;
+
+		*rect = info.rect;
+	} else if (ui->console != NULL) {
+		rc = console_get_size(ui->console, &cols, &rows);
+		if (rc != EOK)
+			return rc;
+
+		rect->p0.x = 0;
+		rect->p0.y = 0;
+		rect->p1.x = cols;
+		rect->p1.y = rows;
+	} else {
+		return ENOTSUP;
+	}
+
+	return EOK;
+}
+
 /** Get clickmatic from UI.
  *
Index: uspace/lib/ui/src/wdecor.c
===================================================================
--- uspace/lib/ui/src/wdecor.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/src/wdecor.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -49,4 +49,8 @@
 #include "../private/wdecor.h"
 
+static void ui_wdecor_btn_min_clicked(ui_pbutton_t *, void *);
+static errno_t ui_wdecor_btn_min_paint(ui_pbutton_t *, void *,
+    gfx_coord2_t *);
+
 static void ui_wdecor_btn_max_clicked(ui_pbutton_t *, void *);
 static errno_t ui_wdecor_btn_max_paint(ui_pbutton_t *, void *,
@@ -56,4 +60,12 @@
 static errno_t ui_wdecor_btn_close_paint(ui_pbutton_t *, void *,
     gfx_coord2_t *);
+
+static ui_pbutton_cb_t ui_wdecor_btn_min_cb = {
+	.clicked = ui_wdecor_btn_min_clicked
+};
+
+static ui_pbutton_decor_ops_t ui_wdecor_btn_min_decor_ops = {
+	.paint = ui_wdecor_btn_min_paint
+};
 
 static ui_pbutton_cb_t ui_wdecor_btn_max_cb = {
@@ -88,4 +100,8 @@
 	/** Window frame width in text mode */
 	wdecor_frame_w_text = 1,
+	/** Window caption horizontal margin */
+	wdecor_cap_hmargin = 4,
+	/** Window caption horizontal margin in text mode */
+	wdecor_cap_hmargin_text = 1,
 	/** Close button cross leg length */
 	wdecor_close_cross_n = 5,
@@ -94,4 +110,8 @@
 	/** Close button cross pen height */
 	wdecor_close_cross_h = 1,
+	/** Minimize icon width */
+	wdecor_min_w = 10,
+	/** Minimize icon height */
+	wdecor_min_h = 10,
 	/** Maximize icon width */
 	wdecor_max_w = 10,
@@ -132,4 +152,18 @@
 	}
 
+	if ((style & ui_wds_minimize_btn) != 0) {
+		rc = ui_pbutton_create(resource, "_", &wdecor->btn_min);
+		if (rc != EOK) {
+			ui_wdecor_destroy(wdecor);
+			return rc;
+		}
+
+		ui_pbutton_set_cb(wdecor->btn_min, &ui_wdecor_btn_min_cb,
+		    (void *)wdecor);
+
+		ui_pbutton_set_decor_ops(wdecor->btn_min,
+		    &ui_wdecor_btn_min_decor_ops, (void *)wdecor);
+	}
+
 	if ((style & ui_wds_maximize_btn) != 0) {
 		rc = ui_pbutton_create(resource, "^", &wdecor->btn_max);
@@ -176,4 +210,5 @@
 		return;
 
+	ui_pbutton_destroy(wdecor->btn_min);
 	ui_pbutton_destroy(wdecor->btn_max);
 	ui_pbutton_destroy(wdecor->btn_close);
@@ -207,4 +242,6 @@
 	ui_wdecor_get_geom(wdecor, &geom);
 
+	if (wdecor->btn_min != NULL)
+		ui_pbutton_set_rect(wdecor->btn_min, &geom.btn_min_rect);
 	if (wdecor->btn_max != NULL)
 		ui_pbutton_set_rect(wdecor->btn_max, &geom.btn_max_rect);
@@ -326,7 +363,10 @@
 		fmt.halign = gfx_halign_center;
 		fmt.valign = gfx_valign_center;
-
-		pos.x = (trect.p0.x + trect.p1.x) / 2;
-		pos.y = (trect.p0.y + trect.p1.y) / 2;
+		fmt.abbreviate = true;
+		fmt.width = geom.caption_rect.p1.x -
+		    geom.caption_rect.p0.x;
+
+		pos.x = (geom.caption_rect.p0.x + geom.caption_rect.p1.x) / 2;
+		pos.y = (geom.caption_rect.p0.y + geom.caption_rect.p1.y) / 2;
 
 		if (wdecor->res->textmode) {
@@ -355,4 +395,10 @@
 			return rc;
 
+		if (wdecor->btn_min != NULL) {
+			rc = ui_pbutton_paint(wdecor->btn_min);
+			if (rc != EOK)
+				return rc;
+		}
+
 		if (wdecor->btn_max != NULL) {
 			rc = ui_pbutton_paint(wdecor->btn_max);
@@ -375,4 +421,14 @@
 }
 
+/** Send decoration minimize event.
+ *
+ * @param wdecor Window decoration
+ */
+void ui_wdecor_minimize(ui_wdecor_t *wdecor)
+{
+	if (wdecor->cb != NULL && wdecor->cb->minimize != NULL)
+		wdecor->cb->minimize(wdecor, wdecor->arg);
+}
+
 /** Send decoration maximize event.
  *
@@ -450,4 +506,5 @@
 	gfx_coord_t btn_x;
 	gfx_coord_t btn_y;
+	gfx_coord_t cap_hmargin;
 
 	/* Does window have a frame? */
@@ -529,4 +586,6 @@
 			geom->btn_max_rect.p1.x = btn_x;
 			geom->btn_max_rect.p1.y = btn_y + 20;
+
+			btn_x -= 20;
 		} else {
 			geom->btn_max_rect.p0.x = btn_x - 3;
@@ -534,4 +593,6 @@
 			geom->btn_max_rect.p1.x = btn_x;
 			geom->btn_max_rect.p1.y = btn_y + 1;
+
+			btn_x -= 3;
 		}
 	} else {
@@ -541,4 +602,39 @@
 		geom->btn_max_rect.p1.y = 0;
 	}
+
+	/* Does window have a minimize button? */
+	if ((wdecor->style & ui_wds_minimize_btn) != 0) {
+		if (wdecor->res->textmode == false) {
+			geom->btn_min_rect.p0.x = btn_x - 20;
+			geom->btn_min_rect.p0.y = btn_y;
+			geom->btn_min_rect.p1.x = btn_x;
+			geom->btn_min_rect.p1.y = btn_y + 20;
+
+			btn_x -= 20;
+		} else {
+			geom->btn_min_rect.p0.x = btn_x - 3;
+			geom->btn_min_rect.p0.y = btn_y;
+			geom->btn_min_rect.p1.x = btn_x;
+			geom->btn_min_rect.p1.y = btn_y + 1;
+
+			btn_x -= 3;
+		}
+	} else {
+		geom->btn_min_rect.p0.x = 0;
+		geom->btn_min_rect.p0.y = 0;
+		geom->btn_min_rect.p1.x = 0;
+		geom->btn_min_rect.p1.y = 0;
+	}
+
+	if (wdecor->res->textmode == false)
+		cap_hmargin = wdecor_cap_hmargin;
+	else
+		cap_hmargin = wdecor_cap_hmargin_text;
+
+	geom->caption_rect.p0.x = geom->title_bar_rect.p0.x +
+	    cap_hmargin;
+	geom->caption_rect.p0.y = geom->title_bar_rect.p0.y;
+	geom->caption_rect.p1.x = btn_x - cap_hmargin;
+	geom->caption_rect.p1.y = geom->title_bar_rect.p1.y;
 }
 
@@ -750,4 +846,10 @@
 	ui_wdecor_get_geom(wdecor, &geom);
 
+	if (wdecor->btn_min != NULL) {
+		claim = ui_pbutton_pos_event(wdecor->btn_min, event);
+		if (claim == ui_claimed)
+			return ui_claimed;
+	}
+
 	if (wdecor->btn_max != NULL) {
 		claim = ui_pbutton_pos_event(wdecor->btn_max, event);
@@ -775,7 +877,21 @@
 }
 
+/** Window decoration minimize button was clicked.
+ *
+ * @param pbutton Minimize button
+ * @param arg Argument (ui_wdecor_t)
+ */
+static void ui_wdecor_btn_min_clicked(ui_pbutton_t *pbutton, void *arg)
+{
+	ui_wdecor_t *wdecor = (ui_wdecor_t *) arg;
+
+	(void) pbutton;
+
+	ui_wdecor_minimize(wdecor);
+}
+
 /** Window decoration (un)maximize button was clicked.
  *
- * @param pbutton Close button
+ * @param pbutton (Un)maximize button
  * @param arg Argument (ui_wdecor_t)
  */
@@ -790,4 +906,22 @@
 	else
 		ui_wdecor_maximize(wdecor);
+}
+
+/** Paint minimize button decoration.
+ *
+ * @param pbutton Push button
+ * @param arg Argument (ui_wdecor_t *)
+ * @param pos Center position
+ */
+static errno_t ui_wdecor_btn_min_paint(ui_pbutton_t *pbutton,
+    void *arg, gfx_coord2_t *pos)
+{
+	ui_wdecor_t *wdecor = (ui_wdecor_t *)arg;
+	errno_t rc;
+
+	rc = ui_paint_minicon(wdecor->res, pos, wdecor_min_w,
+	    wdecor_min_h);
+
+	return rc;
 }
 
Index: uspace/lib/ui/src/window.c
===================================================================
--- uspace/lib/ui/src/window.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/src/window.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -74,4 +74,5 @@
 };
 
+static void wd_minimize(ui_wdecor_t *, void *);
 static void wd_maximize(ui_wdecor_t *, void *);
 static void wd_unmaximize(ui_wdecor_t *, void *);
@@ -83,4 +84,5 @@
 
 static ui_wdecor_cb_t wdecor_cb = {
+	.minimize = wd_minimize,
 	.maximize = wd_maximize,
 	.unmaximize = wd_unmaximize,
@@ -222,4 +224,5 @@
 	display_wnd_params_init(&dparams);
 	dparams.rect = params->rect;
+	dparams.caption = params->caption;
 	/* Only allow making the window larger */
 	gfx_rect_dims(&params->rect, &dparams.min_size);
@@ -227,4 +230,10 @@
 	if ((params->flags & ui_wndf_popup) != 0)
 		dparams.flags |= wndf_popup;
+	if ((params->flags & ui_wndf_topmost) != 0)
+		dparams.flags |= wndf_topmost;
+	if ((params->flags & ui_wndf_system) != 0)
+		dparams.flags |= wndf_system;
+	if ((params->flags & ui_wndf_avoid) != 0)
+		dparams.flags |= wndf_avoid;
 
 	if (ui->display != NULL) {
@@ -651,4 +660,21 @@
 errno_t ui_window_set_caption(ui_window_t *window, const char *caption)
 {
+	errno_t rc;
+
+	/* Set console caption if fullscreen window on console */
+	if (window->ui->console != NULL && window->placement ==
+	    ui_wnd_place_full_screen) {
+		rc = console_set_caption(window->ui->console, caption);
+		if (rc != EOK)
+			return rc;
+	}
+
+	/* Set display window caption if running on display service */
+	if (window->dwindow != NULL) {
+		rc = display_window_set_caption(window->dwindow, caption);
+		if (rc != EOK)
+			return rc;
+	}
+
 	return ui_wdecor_set_caption(window->wdecor, caption);
 }
@@ -891,4 +917,16 @@
 	ui_window_send_unfocus(window);
 	ui_unlock(ui);
+}
+
+/** Window decoration requested window minimization.
+ *
+ * @param wdecor Window decoration
+ * @param arg Argument (window)
+ */
+static void wd_minimize(ui_wdecor_t *wdecor, void *arg)
+{
+	ui_window_t *window = (ui_window_t *) arg;
+
+	ui_window_send_minimize(window);
 }
 
@@ -1017,4 +1055,16 @@
 }
 
+/** Send window minimize event.
+ *
+ * @param window Window
+ */
+void ui_window_send_minimize(ui_window_t *window)
+{
+	if (window->cb != NULL && window->cb->maximize != NULL)
+		window->cb->minimize(window, window->arg);
+	else
+		ui_window_def_minimize(window);
+}
+
 /** Send window maximize event.
  *
@@ -1107,4 +1157,24 @@
 	else
 		return ui_window_def_unfocus(window);
+}
+
+/** Default window minimize routine.
+ *
+ * @param window Window
+ * @return EOK on success or an error code
+ */
+errno_t ui_window_def_minimize(ui_window_t *window)
+{
+	errno_t rc;
+
+	if (window->dwindow != NULL) {
+		rc = display_window_minimize(window->dwindow);
+		if (rc != EOK)
+			goto error;
+	}
+
+	return EOK;
+error:
+	return rc;
 }
 
Index: uspace/lib/ui/test/paint.c
===================================================================
--- uspace/lib/ui/test/paint.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/test/paint.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -354,4 +354,32 @@
 }
 
+/** Paint mimimize icon */
+PCUT_TEST(minicon)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	ui_resource_t *resource = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_minicon(resource, &center, 8, 6);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_resource_destroy(resource);
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
 /** Paint maximize icon */
 PCUT_TEST(maxicon)
Index: uspace/lib/ui/test/pbutton.c
===================================================================
--- uspace/lib/ui/test/pbutton.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/test/pbutton.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2022 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -190,4 +190,59 @@
 }
 
+/** Get light gets internal field */
+PCUT_TEST(get_light)
+{
+	ui_pbutton_t *pbutton;
+	errno_t rc;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	pbutton->light = true;
+	PCUT_ASSERT_TRUE(ui_pbutton_get_light(pbutton));
+
+	pbutton->light = false;
+	PCUT_ASSERT_FALSE(ui_pbutton_get_light(pbutton));
+
+	ui_pbutton_destroy(pbutton);
+}
+
+/** Set light sets internal field */
+PCUT_TEST(set_light)
+{
+	ui_pbutton_t *pbutton;
+	errno_t rc;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_pbutton_set_light(pbutton, true);
+	PCUT_ASSERT_TRUE(pbutton->light);
+
+	ui_pbutton_set_light(pbutton, false);
+	PCUT_ASSERT_FALSE(pbutton->light);
+
+	ui_pbutton_destroy(pbutton);
+}
+
+/** Set caption sets internal field */
+PCUT_TEST(set_caption)
+{
+	ui_pbutton_t *pbutton;
+	errno_t rc;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_STR_EQUALS("Hello", pbutton->caption);
+
+	rc = ui_pbutton_set_caption(pbutton, "World");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_STR_EQUALS("World", pbutton->caption);
+
+	ui_pbutton_destroy(pbutton);
+}
+
 /** Paint button */
 PCUT_TEST(paint)
Index: uspace/lib/ui/test/resource.c
===================================================================
--- uspace/lib/ui/test/resource.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/test/resource.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -134,4 +134,110 @@
 }
 
+/** ui_resource_get_font() returns the font */
+PCUT_TEST(get_font)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	gfx_font_t *font;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	font = ui_resource_get_font(resource);
+	PCUT_ASSERT_EQUALS(resource->font, font);
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_resource_is_textmode() returns the textmode flag */
+PCUT_TEST(is_textmode)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	/* To make sure let's test both true and false case */
+	resource->textmode = true;
+	PCUT_ASSERT_TRUE(ui_resource_is_textmode(resource));
+	resource->textmode = false;
+	PCUT_ASSERT_FALSE(ui_resource_is_textmode(resource));
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_resource_get_wnd_face_color() returns window face color */
+PCUT_TEST(get_wnd_face_color)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	gfx_color_t *color;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	color = ui_resource_get_wnd_face_color(resource);
+	PCUT_ASSERT_EQUALS(resource->wnd_face_color, color);
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_resource_get_wnd_text_color() returns window text color */
+PCUT_TEST(get_wnd_text_color)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	gfx_color_t *color;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	color = ui_resource_get_wnd_text_color(resource);
+	PCUT_ASSERT_EQUALS(resource->wnd_text_color, color);
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
 static errno_t testgc_bitmap_create(void *arg, gfx_bitmap_params_t *params,
     gfx_bitmap_alloc_t *alloc, void **rbm)
Index: uspace/lib/ui/test/ui.c
===================================================================
--- uspace/lib/ui/test/ui.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/test/ui.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -169,4 +169,22 @@
 }
 
+/** ui_is_get_rect() */
+PCUT_TEST(get_rect)
+{
+	ui_t *ui = NULL;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	/* This won't work without a display service */
+	rc = ui_get_rect(ui, &rect);
+	PCUT_ASSERT_ERRNO_VAL(ENOTSUP, rc);
+
+	ui_destroy(ui);
+}
+
 /** ui_lock(), ui_unlock() */
 PCUT_TEST(lock_unlock)
Index: uspace/lib/ui/test/wdecor.c
===================================================================
--- uspace/lib/ui/test/wdecor.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/ui/test/wdecor.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -62,4 +62,5 @@
 };
 
+static void test_wdecor_minimize(ui_wdecor_t *, void *);
 static void test_wdecor_maximize(ui_wdecor_t *, void *);
 static void test_wdecor_unmaximize(ui_wdecor_t *, void *);
@@ -71,4 +72,5 @@
 
 static ui_wdecor_cb_t test_wdecor_cb = {
+	.minimize = test_wdecor_minimize,
 	.maximize = test_wdecor_maximize,
 	.unmaximize = test_wdecor_unmaximize,
@@ -100,4 +102,5 @@
 
 typedef struct {
+	bool minimize;
 	bool maximize;
 	bool unmaximize;
@@ -222,4 +225,30 @@
 	rc = gfx_context_delete(gc);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Test ui_wdecor_minimize() */
+PCUT_TEST(minimize)
+{
+	errno_t rc;
+	ui_wdecor_t *wdecor;
+	test_cb_resp_t resp;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Minimize callback with no callbacks set */
+	ui_wdecor_minimize(wdecor);
+
+	/* Minimize callback with minimize callback not implemented */
+	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
+	ui_wdecor_minimize(wdecor);
+
+	/* Minimize callback with real callback set */
+	resp.minimize = false;
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
+	ui_wdecor_minimize(wdecor);
+	PCUT_ASSERT_TRUE(resp.minimize);
+
+	ui_wdecor_destroy(wdecor);
 }
 
@@ -1014,4 +1043,11 @@
 }
 
+static void test_wdecor_minimize(ui_wdecor_t *wdecor, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->minimize = true;
+}
+
 static void test_wdecor_maximize(ui_wdecor_t *wdecor, void *arg)
 {
